/**
  * Buchungssatz 
  * von Konto
  * nach Konto
  * Betrag
  * Date 
 **/ 

import java.util.Date;


public class BuchungDate implements BuchungInterface {

    final static int NO_KONTO = -1;

    protected int vonKonto = NO_KONTO;
    protected int nachKonto = NO_KONTO;

    protected double betrag = 0.0;

    protected Date zeitStempel = null;

    public BuchungDate(int von, int nach, double b) {
        vonKonto = von;
        nachKonto = nach;
        betrag = b;
        zeitStempel = new Date();
    }

    public int getVonKonto() { return vonKonto; }

    public int getNachKonto() { return nachKonto; }

    public double getBetrag() { return betrag; }

    public Date getZeit() { return zeitStempel; }

    public boolean vor(BuchungInterface b) {
	return zeitStempel.before( b.getZeit() );
    }

    public boolean nach(BuchungInterface b) {
	return zeitStempel.after( b.getZeit() );
    }

    public String toString() {
        String s = "<BuchungDate";
        s +=  " von='"+vonKonto+"'";
        s +=  " nach='"+nachKonto+"'";
	s +=  " betrag='"+betrag+"'";
	s +=  " zeit='"+zeitStempel+"'";
	s +=  " />";
	return s;
    }
}
