
/**
  * Testen einer einfachen URL-Ein- und Datei-Ausgabe
  * Eingabe von einer URL Verbindung
  * Ausgabe auf eine Datei
  *
 **/ 

import java.io.IOException;

public class URLs {

    public static void main(String[] args) {

        Screen sc = new Screen();

        if ( args.length < 1 ) {
	    sc.println("Usage: Dateien <eingabe url> [<ausgabe datei>]");
            return;
	}

        URLEin rein;
        DateiAus raus = null;

        try {
            rein = new URLEin(args[0]);
	}
        catch (IOException e) {
            sc.println("Von URL " + args[0] + " kann nicht gelesen werden.");
            return;
	}

        if ( args.length >= 2 ) {
           try {
               raus = new DateiAus(args[1]);
	   }
           catch (IOException e) {
                 sc.println("Die Datei " 
                            + args[1] 
                            + " ist nicht beschreibbar.");
            return;
           } 
	}

        String ea = "";
        int ein = 0;
	int aus = 0;

        try {
            do {
		ea = rein.readLine(); 
                if ( ea == null ) break;
                ein++;
                if ( raus != null ) { 
                   raus.println(ea); 
		} else {
                   sc.println(ea);
                }
                aus++;
            } while ( !ea.equals("ende") );
	} 
        catch (IOException e) {
	    e.printStackTrace();
	}
	finally {
	    if ( raus != null ) raus.flush();
	}

        try {
	    rein.close();
	    if ( raus != null ) raus.close();
	}
        catch (IOException e) {
	    e.printStackTrace();
	}

        sc.println(""+ein+" Zeilen von " + args[0] + " gelesen");
        sc.print(""+aus+" Zeilen"); 
	if ( args.length >= 2 ) sc.print(" auf "+args[1]); 
        sc.println(" geschrieben");
    }

}
