
/**
  * Persistentes String Objekt
  * hk, 15.12.2001
 **/ 

import java.io.IOException;
import java.io.FileNotFoundException;
import java.io.OptionalDataException;
import java.io.EOFException;
import java.util.ResourceBundle;


public class PersObjekt {

    public final int MAX = 100; 
    private String[] data = null;

    private String fileName = "PersObjekt.temp";
    private ObjectEin rein = null;
    private ObjectAus raus;

    private Screen sc = new Screen();
    private ResourceBundle rb = ResourceBundle.getBundle("PersResource");


    public PersObjekt(String filename) throws IOException {
        if ( filename != null ) 
           if ( !filename.equals("") ) fileName = filename; 

        restore();
        if ( data == null ) {
            data = new String[MAX];
        }

        raus = new ObjectAus(fileName);
    }


    protected void restore() throws IOException {
        try {
            rein = new ObjectEin(fileName);
        }
        catch (FileNotFoundException e) {
	    //            throw new IOException("Die Datei " + fileName + " existiert nicht " + e);
        }

        if ( rein != null ) {
            try {
                 data = (String[]) rein.readObject();
                 rein.close();
            }
            catch (OptionalDataException e) {
                 throw new IOException("Zuviel Daten in Datei " + fileName + e);
            }
            catch (ClassNotFoundException e) {
                 throw new IOException("Zu lesende Klasse nicht bekannt in Datei " + fileName + e);
            }
            catch (EOFException e) {
		//                 throw new IOException("Zuviel Daten in Datei " + fileName + e);
            }
        } 
    }


    protected void store() throws IOException {
        raus.writeObject(data);
        raus.close();
        sc.println(fileName + rb.getString("gesichert"));
    }


    public String[] getData() { return data; }


    public void setData(String[] d) { data = d; }


    protected void finalize() throws IOException {
	store();
    }

}
