

import org.w3c.dom.Document; 
import org.w3c.dom.Node; 
import org.w3c.dom.NodeList; 
import org.w3c.dom.NamedNodeMap; 
import org.w3c.dom.Element; 
import org.w3c.dom.Text; 
import org.w3c.dom.Comment; 
import org.w3c.dom.EntityReference; 
import org.w3c.dom.DocumentType; 
import java.io.IOException;
import org.xml.sax.SAXException;
import java.util.Hashtable;


public class DOMLager {

    Document lagerDoc = null;
    Element lager = null;
    Hashtable artikel = null;

    public DOMLager(Document d) {
        lagerDoc = d;
        lager = lagerDoc.getDocumentElement();
        // setup artikel Hashtable
        artikel = new Hashtable();
        Element art; 
        NodeList nl = lager.getElementsByTagName("artikel"); 
        String nr = null;
        int l = nl.getLength();
	for (int i = 0; i < l; i++ ){
	    art = (Element)nl.item(i);
            nr = art.getAttribute("nr");
            artikel.put(nr,art);
	}
    }


    public String getWert() {
        double betrag = 0.0;
        Element art = null;

        NodeList nl = lager.getElementsByTagName("artikel"); 
        int l = nl.getLength();
	for (int i = 0; i < l; i++ ){
	    art = (Element)nl.item(i);
            betrag += getBestandArtikel(art) * getPreisArtikel(art,"EUR") ;
	}

        String s = "\n<wert >\n" +
                   "<preis einheit=\"EUR\">" + betrag + "</preis>\n" +
                   "</wert>";
        return s;
    }


    public double getPreisArtikel(Element art, String einheit) {
        NodeList pl = art.getElementsByTagName("preis"); 
        // pl.getLength() == 1 
        Element pr = (Element) pl.item(0);
        Text t = (Text) pr.getFirstChild();  
        String s = t.getData(); 
        double b = Double.parseDouble(s);
        String c = pr.getAttribute("einheit");
        if ( !einheit.equals(c) ) {
	    System.err.println("Whrung umrechnen von "+c+" nach "+einheit);
	}
        return b;
    }


    public long getBestandArtikel(Element art) {
        NodeList pl = art.getElementsByTagName("bestand"); 
        // pl.getLength() == 1 
        Element pr = (Element) pl.item(0);
        Text t = (Text) pr.getFirstChild();  
        String s = t.getData(); 
        long z = Long.parseLong(s);
        return z;
    }


    public long getBestandNummer(String nr) {
        Element art = (Element) artikel.get(nr);
        if ( art == null ) {
	    return 0;
	}
        NodeList pl = art.getElementsByTagName("bestand"); 
        // pl.getLength() == 1 
        Element pr = (Element) pl.item(0);
        Text t = (Text) pr.getFirstChild();  
        String s = t.getData(); 
        long z = Long.parseLong(s);
        return z;
    }


    public String getBezeichnungNummer(String nr) {
        Element art = (Element)artikel.get(nr);
        if ( art == null ) {
	    return null;
	}
        NodeList pl = art.getElementsByTagName("bezeichnung"); 
        // pl.getLength() == 1 
        Element pr = (Element) pl.item(0);
        Text t = (Text) pr.getFirstChild();  
        String s = t.getData(); 
        return s;
    }

    public void setBestandNummer(String nr, long b) {
        Element art = (Element) artikel.get(nr);
        if ( art == null ) {
	    return;
	}
        NodeList pl = art.getElementsByTagName("bestand"); 
        // pl.getLength() == 1 
        Element pr = (Element) pl.item(0);
        Text t = (Text) pr.getFirstChild();  
        t.setData(""+b); 
        return;
    }


    public String getBezeichnungGruppeNummer(String nr) {
        Element art = (Element)artikel.get(nr);
        if ( art == null ) {
	    return null;
	}
        NodeList pl = art.getElementsByTagName("bezeichnung"); 
        // pl.getLength() == 1 
        Element pr = (Element) pl.item(0);
        String s = pr.getAttribute("gruppe"); 
        return s;
    }


    public String getPreisNummer(String nr) {
        Element art = (Element)artikel.get(nr);
        if ( art == null ) {
	    return null;
	}
        NodeList pl = art.getElementsByTagName("preis"); 
        // pl.getLength() == 1 
        Element pr = (Element) pl.item(0);
        Text t = (Text) pr.getFirstChild();  
        String s = t.getData(); 
        return s;
    }


    public String getPreisEinheitNummer(String nr) {
        Element art = (Element)artikel.get(nr);
        if ( art == null ) {
	    return null;
	}
        NodeList pl = art.getElementsByTagName("preis"); 
        // pl.getLength() == 1 
        Element pr = (Element) pl.item(0);
        String s = pr.getAttribute("einheit"); 
        return s;
    }


}
