
import java.io.IOException;
import java.io.PrintWriter;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;
import org.xml.sax.Attributes;
import org.xml.sax.InputSource;
import org.xml.sax.helpers.DefaultHandler;
import org.xml.sax.helpers.AttributesImpl;
import org.w3c.dom.Document; 


public class SAXBestellung extends SAXSchreiber {

    DOMLager lager = null;

    public SAXBestellung(PrintWriter p, DOMLager d) {
	pw = p;
        lager = d;
    }

    boolean getAnzahl = false;
    String aNummer = "";

    public void startDocument() {
        super.startDocument();
        pw.println("<!DOCTYPE lieferung SYSTEM \"lieferung.dtd\" >");
        pw.flush();

    }


    public void startElement(String nameuri, String local, String quali, 
                             Attributes attrs) {
        if ( local.equals("bestellung") ) {
           super.startElement(nameuri,"lieferung",null,attrs);
           pw.flush();
           return;
	}
        if ( local.equals("artikel") ) {
           super.startElement(nameuri,local,quali,attrs);
           String s = "\n";
           char[] bs = s.toCharArray();
	   super.characters(bs,0,bs.length);
           super.startElement(nameuri,"bezeichnung",null,null);
           String aNr = attrs.getValue("nr");
           aNummer = aNr;
           s = lager.getBezeichnungGruppeNummer(aNr);
	   s += ", " + lager.getBezeichnungNummer(aNr);
           bs = s.toCharArray();
	   super.characters(bs,0,bs.length);
           super.endElement(null,"bezeichnung",null);
           pw.flush();
           return;
	}
        if ( local.equals("anzahl") ) {
	    getAnzahl = true;
	}
        super.startElement(nameuri,local,quali,attrs);
    } 

    public void endElement(String nameuri, String local, String quali) {
        if ( local.equals("bestellung") ) {
           super.endElement(nameuri,"lieferung",null);
           pw.flush();
           return;
	}
        super.endElement(nameuri,local,quali);
    } 

    public void characters(char ch[], int start, int length) {
        if ( !getAnzahl ) {
           super.characters(ch,start,length);
	   return;
	}
        getAnzahl = false;
        String s = new String(ch,start,length);
        long anzahl = Long.parseLong(s);
        long bestand = lager.getBestandNummer(aNummer);
	if ( bestand >= anzahl ) {
	    bestand -= anzahl;
	} else {
	    anzahl = bestand;
	    bestand = 0;
	}
        lager.setBestandNummer(aNummer,bestand);
	s = "" + anzahl;
        char[] t = s.toCharArray(); 
	super.characters(t,0,t.length);
    } 

}
