
/**
  * Ein einfaches Grep
  * Eingabe von einer Datei oder Standard-Eingabe
  * Ausgabe auf Bildschirm (Standard-Ausgabe)
  *
 **/ 

import java.io.IOException;
import java.io.FileNotFoundException;
import java.io.BufferedReader;

public class Grep {

    public static void main(String[] args) {

        Screen sc = new Screen();

        if ( args.length < 1 ) {
	    sc.println("Usage: Grep <wort> [<eingabe datei>]");
            return;
	}

        String wort = args[0];

        BufferedReader rein = null;

        if ( args.length > 1 ) {
           try {
               rein = new DateiEin(args[1]);
	   }
           catch (IOException e) {
                sc.println("Die Datei " + args[1] + " ist nicht lesbar.");
           }
	}

        if ( rein == null ) rein = new KeyBoard();

        String ea = "";
        int ein = 0;
	int aus = 0;
        int i = -1;

        try {
            do {
                ea = rein.readLine(); 
                if ( ea == null ) break;
                ein++;

                i = ea.indexOf(wort);

                if ( i >= 0 ) {
	           sc.println(ea);
                   aus++;
                }
            } while ( !ea.equals("ende") );
	} 
        catch (IOException e) {
	    e.printStackTrace();
	}

        try {
	    if ( rein != null ) rein.close();
	}
        catch (IOException e) {
	    e.printStackTrace();
	}

        sc.println(""+ein+" Zeilen gelesen");
        sc.println(""+aus+" Zeilen geschrieben");
    }

}
